<?php
/*****************************************
* File      :   $RCSfile: class.newsletter.groups.php,v $
* Project   :   Contenido
* Descr     :   Recipient groups class
* Modified  :   $Date: 2005/05/19 14:51:46 $
*
*  four for business AG, www.4fb.de, generated by HerrB (01.08.2004)
*
* $Id: class.newsletter.groups.php,v 1.1 2005/05/19 14:51:46 timo.hummel Exp $
******************************************/

cInclude("classes", "class.newsletter.recipients.php");

/**
 * Recipient group management class
 */
class RecipientGroupCollection extends ItemCollection {

	/**
	* Constructor Function
	* @param none
	*/
	function RecipientGroupCollection() {
		global $cfg;
		parent::ItemCollection($cfg["tab"]["news_groups"], "idnewsgroup");
		$this->_setItemClass("RecipientGroup");
	}

	/**
	* Loads an item by its ID (primary key)
	* @param $itemID integer Specifies the item ID to load
	*/
	function loadItem ($itemID) {
		$item = new RecipientGroup();
		$item->loadByPrimaryKey($itemID);
		return ($item);
	}

	/**
	* Creates a new group
	* @param $groupname string Specifies the groupname
	* @param $defaultgroup integer Specfies, if group is default group (optional)
	*/
	function create ($groupname, $defaultgroup = 0) {
		global $client, $lang;

		$group = new RecipientGroup;

		$_arrInFilters = array('urlencode', 'htmlspecialchars', 'addslashes');

		$mangledGroupName = $group->_inFilter($groupname);
		$this->select("idclient = '$client' AND idlang='$lang' AND groupname = '$mangledGroupName'");

		if ($obj = $this->next())
		{
			$groupname = $groupname . md5(rand());
		}

		$item = parent::create();

		$item->set("idclient", $client);
		$item->set("idlang", $lang);
		$item->set("groupname", $groupname);
		$item->set("defaultgroup", $defaultgroup);
		$item->store();

		return $item;
	}

	/*
	* Overridden delete method to remove groups from groupmember table
	* before deleting group
	*
	* @param $itemID int specifies the newsletter recipient group
	*/
	function delete ($itemID) {
		$associations = New RecipientGroupMemberCollection;
		$associations->select("idnewsgroup = '$itemID'");

		While ($item = $associations->next()) {
			$associations->delete($item->get("idnewsgroupmember"));
		}
		parent::delete($itemID);
	}
}

/**
 * Single RecipientGroup Item
 */
class RecipientGroup extends Item {

	/**
	* Constructor Function
	* @param string $table The table to use as information source
	*/
	function RecipientGroup() {
		global $cfg;

		parent::Item($cfg["tab"]["news_groups"], "idnewsgroup");
	}
}

/**
 * Recipient group member management class
 */
class RecipientGroupMemberCollection extends ItemCollection {

	/**
	* Constructor Function
	* @param none
	*/
	function RecipientGroupMemberCollection() {
		global $cfg;
		parent::ItemCollection($cfg["tab"]["news_groupmembers"], "idnewsgroupmember");
		$this->_setJoinPartner ('RecipientGroupCollection');
		$this->_setJoinPartner ('RecipientCollection');
		$this->_setItemClass("RecipientGroupMember");
	}

	/**
	* Loads an item by its ID (primary key)
	* @param $itemID integer Specifies the item ID to load
	*/
	function loadItem ($itemID) {
		$item = new RecipientGroupMember();
		$item->loadByPrimaryKey($itemID);
		return ($item);
	}

	/**
	* Creates a new association
	* @param $idrecipientgroup int specifies the newsletter group
	* @param $idrecipient  int specifies the newsletter user
	*/
	function create ($idrecipientgroup, $idrecipient) {
		$this->select("idnewsgroup = '$idrecipientgroup' AND idnewsrcp = '$idrecipient'");

		if ($this->next()) {
			return false;
		}

		$item = parent::create();

		$item->set("idnewsrcp", $idrecipient);
		$item->set("idnewsgroup", $idrecipientgroup);
		$item->store();

		return $item;
	}

	/**
	* Removes an association
	* @param $idrecipientgroup int specifies the newsletter group
	* @param $idrecipient  int specifies the newsletter user
	*/
	function remove ($idrecipientgroup, $idrecipient) {
		$this->select("idnewsgroup = '$idrecipientgroup' AND idnewsrcp = '$idrecipient'");

		if ($item = $this->next()) {
			$this->delete($item->get("idnewsgroupmember"));
		}
	}

	/**
	* Removes all associations from any newsletter group
	* @param $idrecipient  int specifies the newsletter recipient
	*/
	function removeRecipientFromGroups ($idrecipient) {
		$this->select("idnewsrcp = '$idrecipient'");

		While ($item = $this->next()) {
			$this->delete($item->get("idnewsgroupmember"));
		}
	}

		/**
	* Removes all associations of a newsletter group
	* @param $idgroup  int specifies the newsletter recipient group
	*/
	function removeGroup ($idgroup) {
		$this->select("idnewsgroup = '$idgroup'");

		While ($item = $this->next()) {
			$this->delete($item->get("idnewsgroupmember"));
		}
	}

	/**
	* Returns all recipients in a single group
	* @param $idrecipientgroup int specifies the newsletter group
	* @param $asObjects boolean specifies if the function should return objects
	* @return array RecipientRecipient items
	*/
	function getRecipientsInGroup ($idrecipientgroup, $asObjects = true) {
		$this->select("idnewsgroup = '$idrecipientgroup'");

		$objects = array();

		while ($item = $this->next()) {
			if ($asObjects) {
				$recipient = new Recipient;
				$recipient->loadByPrimaryKey($item->get("idnewsrcp"));
				$objects[] = $recipient;
			} else {
				$objects[] = $item->get("idnewsrcp");
			}
		}

		return ($objects);
	}
}

/**
 * Single RecipientGroup Item
 */
class RecipientGroupMember extends Item {

	/**
	* Constructor Function
	* @param string $table The table to use as information source
	*/
	function RecipientGroupMember() {
		global $cfg;

		parent::Item($cfg["tab"]["news_groupmembers"], "idnewsgroupmember");
	}
}

?>
