<?php

/*****************************************
* File      :   $RCSfile: class.newsletter.php,v $
* Project   :   Contenido
* Descr     :   Newsletter recipient class
* Modified  :   $Date: 2006/06/09 14:04:59 $
*
*  four for business AG, www.4fb.de, generated by HerrB (01.08.2004)
*
* $Id: class.newsletter.php,v 1.8 2006/06/09 14:04:59 bjoern.behrens Exp $
******************************************/

cInclude("classes", "class.properties.php");
cInclude("classes", "class.newsletter.recipients.php");
cInclude("classes", "class.newsletter.groups.php");
cInclude("classes", "class.phpmailer.php");
cInclude("classes", "class.lang.php");

/**
 * Newsletter management class
 */
class NewsletterCollection extends ItemCollection
{

	/**
	* Constructor Function
	* @param none
	*/
	function NewsletterCollection()
	{
		global $cfg;
		parent :: ItemCollection($cfg["tab"]["news"], "idnews");
		$this->_setItemClass("Newsletter");
	}

	/**
	* Loads an item by its ID (primary key)
	* @param $itemID integer Specifies the item ID to load
	*/
	function loadItem($itemID)
	{
		$item = new Newsletter();
		$item->loadByPrimaryKey($itemID);
		return ($item);
	}

	/**
	* Creates a new newsletter
	* @param $name string specifies the newsletter name
	*/
	function create($name)
	{
		global $client, $lang, $auth;

		$item = parent :: create();

		/* Check if the newsletter name already exists */
		$this->select("idclient='$client' AND idlang='$lang' AND name='".urlencode($name)."'");

		if ($this->next())
		{
			return $this->create($name."_".substr(md5(rand()), 0, 10));

		}

		$item->set("idart", 0);
		$item->set("idclient", $client);
		$item->set("idlang", $lang);
		$item->set("name", $name);

		$item->set("created", date("Y-m-d H:i:s"), false);
		$item->set("author", $auth->auth["uid"]);
		/* subject, message, newsfrom, newsdate, lastmodified not set*/

		$item->store();

		return $item;
	}

	/**
	* Duplicates the newsletter specified by $itemID
	* @param $itemID integer specifies the newsletter id
	*/
	function duplicate($itemID)
	{
		global $client, $lang, $auth;

		$base = new Newsletter();
		$base->loadByPrimaryKey($itemID);

		$item = parent :: create();

		$item->set("idart", 0);
		$item->set("idclient", $client);
		$item->set("idlang", $lang);
		$item->set("welcome", 0);
		$item->set("name", $base->get("name")."_".substr(md5(rand()), 0, 10));
		$item->set("subject", $base->get("subject"));
		$item->set("message", $base->get("message"));
		$item->set("newsfrom", $base->get("newsfrom"));
		$item->set("newsdate", date("Y-m-d H:i:s"), false);

		$item->set("author", $auth->auth["uid"]);
		$item->set("created", date("Y-m-d H:i:s"), false);

		$item->store();

		return $item;
	}
}

/**
 * Single Newsletter Item
 */
class Newsletter extends Item
{

	/**
	* Constructor Function
	* @param string $table The table to use as information source
	*/
	function Newsletter()
	{
		global $cfg;

		parent :: Item($cfg["tab"]["news"], "idnews");
	}

	function store()
	{
		global $auth;

		$this->set("modified", date("Y-m-d H:i:s"), false);
		$this->set("modifiedby", $auth->auth["uid"]);
		parent :: store();
	}

	/**
	* Sends a newsletter
	* @param $idcatart 	integer specifies id of the 'BlackBox'-acrticle containing the 'BlackBox'-module for management
	* @param $destination 	string 	specifies, who will receive the newsletter ("all", "default" = defaultgroup, 
	*				"selection" = selected groups, "single" = one recepient [e.g. Welcome-Newsletter])
	* @param $to 		array 	specifies, which group of recipients shall receive the 
	*				newsletter ("all", "default" = defaultgroup, "4,5,6" = group IDs)
	* @param $iChunkSize	integer	specifies size of chunks when sending in chunks, 0 = don't send in chunks
	* @param $iChunk		integer	specifies current chunk number when sending in chunks
	* result array		array of recipient names/e-mails
	*/
	function send($idcatart, $destination = "other", $to = "", $iChunkSize = 0, $iChunk = 0)
	{
		global $cfg, $cfgClient, $client, $lang, $auth, $recipient;

		$oRecipients = new RecipientCollection;

		if ($iChunkSize == 0)
		{
			$sLimit = "";
		} else {
			$sLimit = ($iChunk * $iChunkSize).", " .$iChunkSize;
		}

		switch ($destination)
		{
			case "all" :
				// $oRecipients = new RecipientCollection;
				// $oRecipients->select("deactivated='0' AND confirmed='1' AND idclient='$client' AND idlang='$lang'", "", "", $sLimit);
				$sDistinct 	= "";
				$sFrom		= "";
				$sSQL 		= "deactivated='0' AND confirmed='1' AND idclient='$client' AND idlang='$lang'";
				break;
			case "default" :
				/* Not used: The following query would work, but on the wrong object (RecipientGroupMemberCollection, not RecipientCollection).
				 * It would be possible to get the needed object using fetchObject, but only as single items, not as
				 * RecipientCollection-object-list - If I have understood anything correctly... HerrB */
				/* $oRecipients = new RecipientGroupMemberCollection;
				
				$oRecipients->link('RecipientCollection');
				$oRecipients->link('RecipientGroupCollection');
				$oRecipients->setWhere('RecipientCollection.idclient',$client);
				$oRecipients->setWhere('RecipientCollection.idlang',$lang);
				$oRecipients->setWhere('RecipientCollection.deactivated','0');
				$oRecipients->setWhere('RecipientCollection.confirmed','1');
				$oRecipients->setWhere('RecipientGroupCollection.defaultgroup','1');
				$oRecipients->setWhere('RecipientGroupCollection.idclient',$client);
				$oRecipients->setWhere('RecipientGroupCollection.idlang',$lang);
				$oRecipients->query(); */

				// $oRecipients = new RecipientCollection;
				/* $oRecipients->flexSelect("distinct", $cfg["tab"]["news_groups"]." AS groups, ".
							$cfg["tab"]["news_groupmembers"]." AS groupmembers ", 
							"recipientcollection.idclient = '".$client."' AND ".
							"recipientcollection.idlang = '".$lang."' AND ".
							"recipientcollection.deactivated = '0' AND ".
							"recipientcollection.confirmed = '1' AND ".
							"recipientcollection.idnewsrcp = groupmembers.idnewsrcp AND ".
							"groupmembers.idnewsgroup = groups.idnewsgroup AND ".
							"groups.defaultgroup = '1' AND groups.idclient = '".$client."' AND ".
							"groups.idlang = '".$lang."'", "", "", $sLimit); */
				$sDistinct 	= "distinct";
				$sFrom		= $cfg["tab"]["news_groups"]." AS groups, ".$cfg["tab"]["news_groupmembers"]." AS groupmembers ";
                                $sSQL		= "recipientcollection.idclient = '".$client."' AND ".
						  "recipientcollection.idlang = '".$lang."' AND ".
						  "recipientcollection.deactivated = '0' AND ".
						  "recipientcollection.confirmed = '1' AND ".
						  "recipientcollection.idnewsrcp = groupmembers.idnewsrcp AND ".
						  "groupmembers.idnewsgroup = groups.idnewsgroup AND ".
						  "groups.defaultgroup = '1' AND groups.idclient = '".$client."' AND ".
						  "groups.idlang = '".$lang."'";
				break;
			case "selection" :
				// $oRecipients = new RecipientCollection;
				if (is_array($to) && count($to) > 0)
				{
					$groups = "'";
					foreach ($to as $group)
					{
						if ($groups != "'")
						{
							$groups .= "','";
						}
						$groups .= urlencode($group);
					}
					$groups .= "'";

					// $oRecipients->flexSelect("distinct", $cfg["tab"]["news_groupmembers"]." AS groupmembers ", "recipientcollection.idclient = '".$client."' AND "."recipientcollection.idlang = '".$lang."' AND "."recipientcollection.deactivated = '0' AND "."recipientcollection.confirmed = '1' AND "."recipientcollection.idnewsrcp = groupmembers.idnewsrcp AND "."groupmembers.idnewsgroup IN (".$groups.")", "", "", $sLimit);
					$sDistinct 	= "distinct";
					$sFrom		= $cfg["tab"]["news_groupmembers"]." AS groupmembers ";
					$sSQL		= "recipientcollection.idclient = '".$client."' AND ".
							  "recipientcollection.idlang = '".$lang."' AND ".
							  "recipientcollection.deactivated = '0' AND ".
							  "recipientcollection.confirmed = '1' AND ".
							  "recipientcollection.idnewsrcp = groupmembers.idnewsrcp AND ".
							  "groupmembers.idnewsgroup IN (".$groups.")";
				} else {
					$destination = "other";
				}
				break;
			case "single" :
				$oRecipients = new RecipientCollection;
				if (is_numeric($to))
				{
					// $oRecipients->select("idnewsrcp = '".$to."'");
					$sDistinct 	= "";
					$sFrom		= "";
					$sSQL		= "idnewsrcp = '".$to."'";
				} else {
					$destination = "other";
				}
				break;
			default:
				$destination = "other";
		}
		unset ($result);
		$result = array();

		if ($destination == "other")
		{
			$result[] = 0;
			$result[] = i18n("No recipients found");
		} else {
			$oRecipients->flexSelect($sDistinct, $sFrom, $sSQL, "", "", "");
			$iTotalCount = $oRecipients->count();

			$oRecipients->flexSelect($sDistinct, $sFrom, $sSQL, "", "", $sLimit);
			$iBlockCount = $oRecipients->count();
			if ($iTotalCount == 0)
			{
				$result[] = 0;
				$result[] = i18n("No recipients found");
			} else if ($iBlockCount == 0) {
				$result[] = 0;
				$result[] = i18n("No (more) recipients found");
			} else {
				$result[] = $iTotalCount;
				$from	  = $this->get("newsfrom");
				$subject  = $this->get("subject");
				$message  = $this->get("message");

				$oLanguage = new Language;
    				$oLanguage->loadByPrimaryKey($lang);
				$sFormatDate = $oLanguage->getProperty("dateformat", "date");
				$sFormatTime = $oLanguage->getProperty("dateformat", "time");
				if ($sFormatDate == "") {
					$sFormatDate = "%d.%m.%Y";
				}
				if ($sFormatTime == "") {
					$sFormatTime = "%H:%M";
				}

				$message = str_replace("MAIL_NUMBER", $iTotalCount,           $message);
				$message = str_replace("MAIL_DATE",   strftime($sFormatDate), $message);
				$message = str_replace("MAIL_TIME",   strftime($sFormatTime), $message);

				// Preventing double lines in mail, you may wish to disable this function on windows servers
				if (!getSystemProperty("newsletter", "disablernreplacement"))
				{
					$message = str_replace("\r\n", "\n", $message);
				}
				$sPath = $cfgClient[$client]["path"]["htmlpath"]."front_content.php?changelang=".$lang."&idcatart=".$idcatart."&";

				// Enabling plugin interface
				if (getSystemProperty("newsletter", "newsletter-recipients-plugin") == "true") {
					$bPluginEnabled = true;
					$aPlugins       = array();

					if (is_array($cfg['plugins']['recipients']))
					{
						foreach ($cfg['plugins']['recipients'] as $plugin)
						{
							plugin_include("recipients", $plugin."/".$plugin.".php");
							if (function_exists("recipients_".$plugin."_wantedVariables")) {
								$aPlugins[$plugin] = call_user_func("recipients_".$plugin."_wantedVariables");
							}	
						}
					}
				} else {
					setSystemProperty("newsletter", "newsletter-recipients-plugin", "false");
					$bPluginEnabled = false;
				}

				// Don't change name of $recipient variable as it is used in plugins!
				while ($recipient = $oRecipients->next())
				{
					$to   = $recipient->get("email");
					$name = $recipient->get("name");
					if (empty ($name))
					{
						$name = $to;
					}
					$key  = $recipient->get("hash");

					if (strlen($key) == 30) // Prevents sending without having a key
					{
						$message2 = str_replace("MAIL_NAME", "$name", $message);
						if ($bPluginEnabled)
						{
							foreach ($aPlugins as $sPlugin => $aPluginVar) {
								foreach ($aPluginVar as $sPluginVar) {
									$message2 = str_replace("MAIL_".strtoupper($sPluginVar), call_user_func("recipients_".$sPlugin."_getvalue", $sPluginVar), $message2);
								}
							}
						}
						$message2 = str_replace("MAIL_UNSUBSCRIBE", $sPath."unsubscribe=".$key, $message2);
						$message2 = str_replace("MAIL_CHANGE", $sPath."change=".$key, $message2);
						$message2 = str_replace("MAIL_STOP", $sPath."stop=".$key, $message2);
						$message2 = str_replace("MAIL_GOON", $sPath."goon=".$key, $message2);

						$mail = new phpmailer();
						$mail->From	= $from;
						$mail->FromName	= $from;
						$mail->AddAddress($to);
						$mail->Mailer	= "mail";
						$mail->Subject	= $subject;
						$mail->Body	= $message2."\n\n".$foot;
						// $mail->AltBody	= $body;

						if (!$mail->Send())
						{
							$result[] = $name." (".$to."): ".sprintf(i18n("Newsletter to %s could not be sent"), $to);
						} else {
							$result[] = $name." (".$to."): ".i18n("Sent successfully");
						}
					} else {
						$result[] = $name." (".$to."): ".sprintf(i18n("Newsletter to %s could not be sent (recipient has an incompatible or empty key)."), $to);
					}
				}
			}
		}
		return $result;
	}
}

?>