<?php
/*****************************************
* File      :   $RCSfile: include.newsletter_edit.php,v $
* Project   :   Contenido
* Descr     :   Frontend user editor
* Modified  :   $Date: 2006/06/09 14:04:59 $
*
*  four for business AG, www.4fb.de, updated by HerrB
*
* $Id: include.newsletter_edit.php,v 1.13 2006/06/09 14:04:59 bjoern.behrens Exp $
******************************************/
cInclude("classes", "widgets/class.widgets.page.php");
cInclude("classes", "class.ui.php");
cInclude("classes", "class.htmlelements.php");
cInclude("classes", "class.newsletter.php");
cInclude("classes", "class.properties.php");

$page        = new cPage;
$newsletters = new NewsletterCollection;

if (is_array($cfg['plugins']['newsletters'])) {
	foreach ($cfg['plugins']['newsletters'] as $plugin) {
		plugin_include("newsletters", $plugin."/".$plugin.".php");	
	}
}

if ($action == "news_create" && $perm->have_perm_area_action("news", "news_create")) {
	$newsletter = $newsletters->create(i18n("-- new newsletter --"));
	$idnewsletter = $newsletter->get("idnews");
	$page->setReload();		
} else if ($action == "news_duplicate" && $perm->have_perm_area_action("news", "news_create")) {
	$newsletter = $newsletters->duplicate($idnewsletter);
	$idnewsletter = $newsletter->get("idnews");
	$page->setReload();		
} else if ($action == "news_delete" && $perm->have_perm_area_action("news", "news_delete")) {
	$newsletters->delete($idnewsletter);
	$idnewsletter = 0;
	$page->setReload();
}

$newsletter = new Newsletter;
$newsletter->loadByPrimaryKey($idnewsletter);

if ($newsletter->virgin == false && $newsletter->get("idclient") == $client && $newsletter->get("idlang") == $lang) {
	if ($action == "news_save" && $perm->have_perm_area_action($area, $action)) {
		$page->setReload();
		$messages = array();

		/* Changing e.g. \' back to ' (magic_quotes) */
		$name     = stripslashes($name);
		$newsfrom = stripslashes($newsfrom);
		$subject  = stripslashes($subject);
		$message  = stripslashes($message);
      		
		if ($newsletter->get("name") != $name) {
				$newsletters->resetQuery();
				$newsletters->setWhere("name", $name);
				$newsletters->setWhere("idclient", $client);
				$newsletters->setWhere("idlang", $lang);
				$newsletters->query();
				
    			if ($newsletters->next()) {
    				$messages[] = i18n("Could not set new newsletter name: name already exists");	
    			} else {
    				$newsletter->set("name", $name);
	    		}
		}
		if ($newsletter->get("welcome") != $welcome && $welcome) {
			/* Welcome option has been enabled, disable for other newsletters */
			$welcomenews = new Newsletter;
			$newsletters->select("welcome = '1' AND idclient='$client' AND idlang='$lang'");
			if ($welcomenews = $newsletters->next()) {
				$welcomenews->set("welcome",0);
				$welcomenews->store();
			}
		}
		$newsletter->set("welcome", $welcome);
		$newsletter->set("newsfrom", $newsfrom);
		$newsletter->set("subject", $subject);
		$newsletter->set("message", $message);
		
    		/* Check out if there are any plugins */
    		if (is_array($cfg['plugins']['newsletters'])) {
    			foreach ($cfg['plugins']['newsletters'] as $plugin) {
    				if (function_exists("newsletters_".$plugin."_wantedVariables") && function_exists("newsletters_".$plugin."_store")) {
        				$wantVariables = call_user_func("newsletters_".$plugin."_wantedVariables");
        			
	        			if (is_array($wantVariables)) {
        					$varArray = array();
        					
        					foreach ($wantVariables as $value) {
	        					$varArray[$value] = stripslashes($GLOBALS[$value]);	
        					}	
        				}
        				$store = call_user_func("newsletters_".$plugin."_store", $varArray);
	    			}
    			}
	    	}
    	
	    	$newsletter->store();		
	}
	
	if (count($messages) > 0) {
		$notis = $notification->returnNotification("warning", implode("<br>", $messages)) . "<br>";
	}
	
	$form = new UI_Table_Form("properties");
	$form->setVar("frame", $frame);
	$form->setVar("area", $area);
	$form->setVar("action", "news_save");
	$form->setVar("idnewsletter", $idnewsletter);

	$form->addHeader(i18n("Edit newsletter"));

	$name 		= new cHTMLTextbox("name", $newsletter->get("name"),40);
	$welcome	= new cHTMLCheckbox("welcome", "1");
	$welcome->setChecked($newsletter->get("welcome"));
	$newsfrom 	= new cHTMLTextbox("newsfrom", $newsletter->get("newsfrom"),40);
	$subject 	= new cHTMLTextarea("subject", $newsletter->get("subject"),80,3);
	$message	= new cHTMLTextarea("message", $newsletter->get("message"),80,20);
	
	$form->add(i18n("Name"), $name->render());
	$form->add(i18n("Welcome-Newsletter"), $welcome->toHTML(false));
	$form->add(i18n("From"), $newsfrom->render());
	$form->add(i18n("Subject"), $subject->render());
	$form->add(i18n("Message"), $message->render());

	$messageHelp = 	"<b>". i18n("Special message tags (will be replaced when sending)").":</b><br>".
			"MAIL_NAME: ".i18n("Name of the recipient")."<br>".
			"MAIL_DATE: ".i18n("Date, when the mail has been sent")."<br>".
			"MAIL_TIME: ".i18n("Time, when the mail has been sent")."<br>".
			"MAIL_NUMBER: ".i18n("Number of recipients")."<br>".
			"MAIL_CHANGE: ".i18n("Link to change the e-mail adress")."<br>".
			"MAIL_UNSUBSCRIBE: ".i18n("Link to unsubscribe")."<br>".
			"MAIL_STOP: ".i18n("Link to pause the subscription")."<br>".
			"MAIL_GOON: ".i18n("Link to resume the subscription");

	// Enabling plugin interface
	if (getSystemProperty("newsletter", "newsletter-recipients-plugin") == "true") {
		$messageHelp .= "<br><br><strong>".mi18n("Additional message tags from recipients plugins:")."</strong><br>";

		if (is_array($cfg['plugins']['recipients'])) {
			foreach ($cfg['plugins']['recipients'] as $plugin) {
				plugin_include("recipients", $plugin."/".$plugin.".php");

				if (function_exists("recipients_".$plugin."_wantedVariables")) {
					$aPluginVars = call_user_func("recipients_".$plugin."_wantedVariables");
					foreach ($aPluginVars as $sPluginVar) {
						$messageHelp .= "MAIL_".strtoupper($sPluginVar)."<br />";
					}
				}	
			}
		}
	} else {
		setSystemProperty("newsletter", "newsletter-recipients-plugin", "false");
	}

	$form->add("", $messageHelp);
	
	$pluginOrder = trim_array(explode(",",getSystemProperty("plugin", "newsletters-pluginorder")));
	
	/* Check out if there are any plugins */
	if (is_array($pluginOrder)) {
		foreach ($pluginOrder as $plugin) {
			if (function_exists("newsletters_".$plugin."_getTitle") && function_exists("newsletters_".$plugin."_display")) {
	    			$plugTitle = call_user_func("newsletters_".$plugin."_getTitle");
    				$display = call_user_func("newsletters_".$plugin."_display", $newsletter);
    			
    				if (is_array($plugTitle) && is_array($display)) {
	    				foreach ($plugTitle as $key => $value) {
	    					$form->add($value, $display[$key]);	
    					}
	    			} else {
    					if (is_array($plugTitle) || is_array($display)) {
	    					$form->add("WARNING", "The plugin $plugin delivered an array for the displayed titles, but did not return an array for the contents.");
    					} else {
    						$form->add($plugTitle, $display);
					}
				}
			}
		}
		
		$form->add(i18n("Author"), $classuser->getUserName($newsletter->get("author")) . " (". $newsletter->get("created").")" ); 
		$form->add(i18n("Last modified by"), $classuser->getUserName($newsletter->get("modifiedby")). " (". $newsletter->get("modified").")" );	
	}
	$page->setContent($notis . $form->render(true));
} else {
	$page->setContent($notis . "");
}

$page->render();
?>
