<?php
/*****************************************
* File      :   $RCSfile: include.recipients_edit.php,v $
* Project   :   Contenido
* Descr     :   Frontend user editor
* Modified  :   $Date: 2005/12/04 14:25:47 $
*
*  four for business AG, www.4fb.de, updated by HerrB
*
* $Id: include.recipients_edit.php,v 1.13 2005/12/04 14:25:47 timo.hummel Exp $
******************************************/
cInclude("classes", "widgets/class.widgets.page.php");
cInclude("classes", "class.ui.php");
cInclude("classes", "class.htmlelements.php");
cInclude("classes", "class.newsletter.recipients.php");
cInclude("classes", "class.newsletter.groups.php");
cInclude("classes", "class.properties.php");

$page       = new cPage;
$recipients = new RecipientCollection;
$recipient  = new Recipient;
$recipient->loadByPrimaryKey($idrecipient);

if (is_array($cfg['plugins']['recipients'])) {
	foreach ($cfg['plugins']['recipients'] as $plugin) {
		plugin_include("recipients", $plugin."/".$plugin.".php");	
	}
}

if ($action == "recipients_create" && $perm->have_perm_area_action("recipients", "recipients_create")) {
	$recipient = $recipients->create("mail@domain.tld"," ".i18n("-- new recipient --"));
	$idrecipient = $recipient->get("idnewsrcp");
	$page->setReload();		
} elseif ($action == "recipients_delete" && $perm->have_perm_area_action("recipients", "recipients_delete")) {
	$recipients->delete($idrecipient);
	$idrecipient = 0;
	$recipient = new Recipient;	
	$page->setReload();
} elseif ($action == "recipients_purge" && $perm->have_perm_area_action("recipients", "recipients_delete")) {
	$timeframe = getSystemProperty("newsletter","purgetimeframe");
	if (!$timeframe) {
		$timeframe = 30;
	}
	$purgedrecipients = $recipients->purge($timeframe);
	/* backslashdollar: There is a problem translating \$ - it is either not recognized or translated correctly (using poEdit) */
	$notis = $notification->returnNotification("info", sprintf(str_replace("backslashdollar", "\$", i18n("%1backslashdollard recipients, which hasn't been confirmed since more than %2backslashdollard days has been removed.")),$purgedrecipients,$timeframe));
	$idrecipient = 0;
	$recipient = new Recipient;	
	$page->setReload();
} 

if ($recipient->virgin == false && $recipient->get("idclient") == $client && $recipient->get("idlang") == $lang) {
	if ($action == "recipients_save" && $perm->have_perm_area_action($area, $action)) {
		$page->setReload();
		$messages = array();

		$name = stripslashes($name);
		$email = stripslashes($email);

		$recipient->set("name", $name);
		$email = strtolower($email); // E-Mail always in lower case
		if ($recipient->get("email") != $email) {
				$recipients->resetQuery();
				$recipients->setWhere("email", $email);
				$recipients->setWhere("idclient", $client);
				$recipients->setWhere("idlang", $lang);
				$recipients->query();
    			
    			if ($recipients->next()) {
    				$messages[] = i18n("Could not set new e-mail adress: Other recipient with same e-mail adress already exists");	
    			} else {
    				$recipient->set("email", $email);
	    		}
		}
				
		if ($recipient->get("confirmed") != $confirmed && $confirmed) {
			$recipient->set("confirmeddate", date("Y-m-d H:i:s"), false);
		} elseif (!$confirmed) {
			$recipient->set("confirmeddate", "0000-00-00 00:00:00", false);	
		}
		$recipient->set("confirmed", $confirmed);
		$recipient->set("deactivated", $deactivated);
		
    		/* Check out if there are any plugins */
    		if (is_array($cfg['plugins']['recipients'])) {
    			foreach ($cfg['plugins']['recipients'] as $plugin) {
    				if (function_exists("recipients_".$plugin."_wantedVariables") && function_exists("recipients_".$plugin."_store")) {
        				$wantVariables = call_user_func("recipients_".$plugin."_wantedVariables");
        			
	        			if (is_array($wantVariables)) {
        					$varArray = array();
        					
        					foreach ($wantVariables as $value) {
	        					$varArray[$value] = stripslashes($GLOBALS[$value]);	
        					}	
        				}
        				$store = call_user_func("recipients_".$plugin."_store", $varArray);
	    			}
    			}
	    	}
    	
	    	$recipient->store();		
	}
	
	if (count($messages) > 0) {
		$notis = $notification->returnNotification("warning", implode("<br>", $messages)) . "<br>";
	}
	
	$form = new UI_Table_Form("properties");
	$form->setVar("frame", $frame);
	$form->setVar("area", $area);
	$form->setVar("action", "recipients_save");
	$form->setVar("idrecipient", $idrecipient);

	$form->addHeader(i18n("Edit recipient"));

	$name 		= new cHTMLTextbox("name", $recipient->get("name"),40);
	$email 		= new cHTMLTextbox("email", $recipient->get("email"),40);
	$confirmed 	= new cHTMLCheckbox("confirmed","1");
	$confirmed->setChecked($recipient->get("confirmed"));
	$deactivated 	= new cHTMLCheckbox("deactivated","1");
	$deactivated->setChecked($recipient->get("deactivated"));
	
	$form->add(i18n("Name"), $name->render());
	$form->add(i18n("E-Mail"), $email->render());
	$form->add(i18n("Confirmed"), $confirmed->toHTML(false) . " (" . $recipient->get("confirmeddate") . ")");
	$form->add(i18n("Deactivated"), $deactivated->toHTML(false));
	
	$pluginOrder = trim_array(explode(",",getSystemProperty("plugin", "recipients-pluginorder")));
	
	/* Check out if there are any plugins */
	if (is_array($pluginOrder)) {
		foreach ($pluginOrder as $plugin) {
			if (function_exists("recipients_".$plugin."_getTitle") &&
			    function_exists("recipients_".$plugin."_display")) {
    				$plugTitle = call_user_func("recipients_".$plugin."_getTitle");
    				$display = call_user_func("recipients_".$plugin."_display", $recipient);
    			
    				if (is_array($plugTitle) && is_array($display)) {
    					foreach ($plugTitle as $key => $value) {
    						$form->add($value, $display[$key]);	
    					}
    				} else {
    					if (is_array($plugTitle) || is_array($display)) {
    						$form->add("WARNING", "The plugin $plugin delivered an array for the displayed titles, but did not return an array for the contents.");
    					} else {
    						$form->add($plugTitle, $display);
					}
				}
			}
		}
		
		$form->add(i18n("Author"), $classuser->getUserName($recipient->get("author")) . " (". $recipient->get("created").")" ); 
		$form->add(i18n("Last modified by"), $classuser->getUserName($recipient->get("modifiedby")). " (". $recipient->get("lastmodified").")" );
	}
	$page->setContent($notis . $form->render(true));
} else {
	$page->setContent($notis . "");	
}

$page->render();
?>