<?php

if (!function_exists('file_get_contents')) {
  function file_get_contents($filename, $use_include_path = 0) {
   $data = '';
   $file = @fopen($filename, "rb", $use_include_path);
   if ($file) {
     while (!feof($file)) $data .= fread($file, 1024);
     fclose($file);
   } else {
     /* There was a problem opening the file. */
     return FALSE;
   }
   return $data;
  }
}

/**
 * cGenerateSetupStepsDisplay
 * 
 * Generates the step display.
 * 
 * @param iCurrentStep integer The current step to display active.
 */
function cGenerateSetupStepsDisplay ($iCurrentStep)
{
	$steps = array();


	
	for ($i=1; $i < C_SETUP_STEPS + 1; $i++)
	{
		$alphaImage = new cHTMLAlphaImage;
		
		$alphaImage->setWidth(C_SETUP_STEPWIDTH);
		$alphaImage->setHeight(C_SETUP_STEPHEIGHT);			
		
		if ($iCurrentStep == $i)
		{
			
			$alphaImage->setSrc(sprintf(C_SETUP_STEPFILE_ACTIVE,$i));
		} else {
			$alphaImage->setSrc(sprintf(C_SETUP_STEPFILE,$i));
		}
		
		$steps[] = $alphaImage->render();
	}
	
	return implode("", $steps);
}
?>